﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.Storage;

// The Settings Flyout item template is documented at http://go.microsoft.com/fwlink/?LinkId=273769

namespace Sharing
{
    public sealed partial class CustomSettings : SettingsFlyout
    {
        private ApplicationDataContainer settingsData;

        public CustomSettings()
        {
            this.InitializeComponent();
            settingsData = ApplicationData.Current.LocalSettings;
            if (settingsData.Values.ContainsKey("setting"))
            {
                this.SettingToggle.IsOn = ((string)settingsData.Values["setting"] == "On" ? true : false);
            }
            else
            {
                settingsData.Values["setting"] = "Off";
                this.SettingToggle.IsOn = false;
            }
        }

        private void SettingToggle_Toggled(object sender, RoutedEventArgs e)
        {
            
            settingsData.Values["setting"] = (this.SettingToggle.IsOn ? "On" : "Off");
            ApplicationData.Current.SignalDataChanged();
        }
    }
}
