﻿using Chapter18.Common;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage.Streams;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Basic Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234237

namespace Chapter18
{
    /// <summary>
    /// A basic page that provides characteristics common to most applications.
    /// </summary>
    public sealed partial class MainPage : Page
    {

        private NavigationHelper navigationHelper;
        private ObservableDictionary defaultViewModel = new ObservableDictionary();
        private ColorCollection AllColors;

        public ObservableDictionary DefaultViewModel
        {
            get { return this.defaultViewModel; }
        }

 
        public NavigationHelper NavigationHelper
        {
            get { return this.navigationHelper; }
        }


        public MainPage()
        {
            this.InitializeComponent();
            this.navigationHelper = new NavigationHelper(this);
            this.navigationHelper.LoadState += navigationHelper_LoadState;
            this.navigationHelper.SaveState += navigationHelper_SaveState;
            AllColors = new ColorCollection();

            
        }

        
        private void navigationHelper_LoadState(object sender, LoadStateEventArgs e)
        {
        }

        
        private void navigationHelper_SaveState(object sender, SaveStateEventArgs e)
        {
        }

        #region NavigationHelper registration

        /// The methods provided in this section are simply used to allow
        /// NavigationHelper to respond to the page's navigation methods.
        /// 
        /// Page specific logic should be placed in event handlers for the  
        /// <see cref="GridCS.Common.NavigationHelper.LoadState"/>
        /// and <see cref="GridCS.Common.NavigationHelper.SaveState"/>.
        /// The navigation parameter is available in the LoadState method 
        /// in addition to page state preserved during an earlier session.

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            navigationHelper.OnNavigatedTo(e);
        }

        protected override void OnNavigatedFrom(NavigationEventArgs e)
        {
            navigationHelper.OnNavigatedFrom(e);
        }

        #endregion

        private void ColorSearch_QuerySubmitted(SearchBox sender, SearchBoxQuerySubmittedEventArgs args)
        {
            var x = args.QueryText;
            this.Frame.Navigate(typeof(ColorSearchResults), x);
        }

        private void ColorSearch_SuggestionsRequested(SearchBox sender, SearchBoxSuggestionsRequestedEventArgs args)
        {
            var suggestions = args.Request.SearchSuggestionCollection;

            foreach (ColorDetails c in AllColors)
            {
                if (c.ColorName.Equals(args.QueryText,
                StringComparison.CurrentCultureIgnoreCase))
                {
                    Uri imageUri = new Uri("ms-appx:///Assets/Logo.scale-100.png");
                    var imageSource = RandomAccessStreamReference.CreateFromUri(imageUri);
                    suggestions.AppendResultSuggestion(c.ColorName, c.HexValue, c.ColorName, imageSource, "");
                    suggestions.AppendSearchSeparator("");
                    break;
                }
            }



            foreach (ColorDetails c in AllColors)
            {
                if (c.ColorName.StartsWith(args.QueryText,
                StringComparison.CurrentCultureIgnoreCase))
                    suggestions.AppendQuerySuggestion(c.ColorName);
                if (suggestions.Size == 25)
                    break;
            }
        }

        private void ColorSearch_ResultSuggestionChosen(SearchBox sender, SearchBoxResultSuggestionChosenEventArgs args)
        {
           
            this.Frame.Navigate(typeof(ColorItem), args.Tag);
        }
    }


    public enum ColorGroup
    {
        Red, Green, Blue, Neutral
    }


    


}
