﻿' The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238



Imports ColorBrowser.ColorCollection

Public NotInheritable Class MainPage
    Inherits Page

    Public Sub New()
        InitializeComponent()
        Dim ColorList As ColorCollection = New ColorCollection()
        Dim groupedColors = From c In ColorList
                            Order By c.ColorName
                            Group c By c.Key
                            Into Group
        
        ColorCVS.Source = groupedColors
        AddHandler ColorCVS.View.CurrentChanged, AddressOf View_CurrentChanged
    End Sub
    Private Sub View_CurrentChanged(sender As Object, e As Object)
        ListOfColors.ScrollIntoView(ColorCVS.View.CurrentItem)
    End Sub

    Private Sub MoveFirst_Click(sender As Object, e As RoutedEventArgs)
        ColorCVS.View.MoveCurrentToFirst()
    End Sub


    Private Sub MovePrevious_Click(sender As Object, e As RoutedEventArgs)
        ColorCVS.View.MoveCurrentToPrevious()
        If ColorCVS.View.IsCurrentBeforeFirst Then
            ColorCVS.View.MoveCurrentToFirst()
        End If
    End Sub

    Private Sub MoveNext_Click(sender As Object, e As RoutedEventArgs)
        ColorCVS.View.MoveCurrentToNext()
        If ColorCVS.View.IsCurrentAfterLast Then
            ColorCVS.View.MoveCurrentToLast()
        End If
    End Sub

    Private Sub MoveLast_Click(sender As Object, e As RoutedEventArgs)
        ColorCVS.View.MoveCurrentToLast()
    End Sub
End Class
