﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports Windows.UI
Imports System.Collections.ObjectModel
Imports System.Reflection

Public Class ColorCollection
    Inherits ObservableCollection(Of ColorDetails)

    Public Sub New()
        LoadStandardColors()
    End Sub
    Public Sub LoadStandardColors()
        Dim t As Type = GetType(Colors)
        Dim pList As IEnumerable(Of PropertyInfo) = t.GetTypeInfo().DeclaredProperties

        For Each p As PropertyInfo In pList
            Dim cd As ColorDetails = New ColorDetails()
            Dim c As Color = DirectCast(p.GetValue(Nothing), Color)
            cd.ColorName = p.Name
            cd.ActualColor = c
            cd.Red = Color.FromArgb(255, c.R, 0, 0).ToString()
            cd.Green = Color.FromArgb(255, 0, c.G, 0).ToString()
            cd.Blue = Color.FromArgb(255, 0, 0, c.B).ToString()
            cd.HexValue = c.ToString()
            cd.Key = p.Name.Substring(0, 1)

            Add(cd)
        Next
    End Sub
End Class
