﻿Imports Windows.UI.StartScreen

Public NotInheritable Class Secondary
    Inherits Page

    Public ReadOnly Property NavigationHelper As Common.NavigationHelper
        Get
            Return Me._navigationHelper
        End Get
    End Property
    Private _navigationHelper As Common.NavigationHelper

    Public ReadOnly Property DefaultViewModel As Common.ObservableDictionary
        Get
            Return Me._defaultViewModel
        End Get
    End Property
    Private _defaultViewModel As New Common.ObservableDictionary()

    Public Sub New()

        InitializeComponent()
        Me._navigationHelper = New Common.NavigationHelper(Me)
        AddHandler Me._navigationHelper.LoadState, AddressOf NavigationHelper_LoadState
        AddHandler Me._navigationHelper.SaveState, AddressOf NavigationHelper_SaveState
    End Sub

    Private Sub NavigationHelper_LoadState(sender As Object, e As Common.LoadStateEventArgs)

    End Sub

    Private Sub NavigationHelper_SaveState(sender As Object, e As Common.SaveStateEventArgs)

    End Sub

#Region "NavigationHelper registration"

    ''' The methods provided in this section are simply used to allow
    ''' NavigationHelper to respond to the page's navigation methods.
    ''' 
    ''' Page specific logic should be placed in event handlers for the  
    ''' <see cref="Common.NavigationHelper.LoadState"/>
    ''' and <see cref="Common.NavigationHelper.SaveState"/>.
    ''' The navigation parameter is available in the LoadState method 
    ''' in addition to page state preserved during an earlier session.

    Protected Overrides Sub OnNavigatedTo(e As NavigationEventArgs)
        _navigationHelper.OnNavigatedTo(e)
    End Sub

    Protected Overrides Sub OnNavigatedFrom(e As NavigationEventArgs)
        _navigationHelper.OnNavigatedFrom(e)
    End Sub

#End Region

    Private Shared Function GetElementRect(element As FrameworkElement) As Rect
        Dim t As GeneralTransform = element.TransformToVisual(Nothing)
        Dim p As Point = t.TransformPoint(New Point())
        Return New Rect(p, New Size(element.ActualWidth, element.ActualHeight))
    End Function

    Private Async Sub Button_Click(sender As Object, e As RoutedEventArgs)
        Dim pageTile As SecondaryTile = New SecondaryTile("SecondaryPage")
        pageTile.DisplayName = "Secondary page"
        pageTile.Arguments = "Secondary page"
        pageTile.VisualElements.Square150x150Logo =
            New Uri("ms-appx:///Assets/Square150x150Logo.png")
        pageTile.TileId = "TilesAndNotifications.SecondaryPage"

        Dim showRect As Rect = GetElementRect(DirectCast(Me.PinButton, FrameworkElement))
        Dim Pinned As Boolean = Await pageTile.RequestCreateForSelectionAsync(showRect,
                                                                              Windows.UI.Popups.Placement.Right)
    End Sub
End Class
